package com.example.demo.coll.controller;


import com.alibaba.fastjson.JSONObject;
import com.alipay.mychain.sdk.api.utils.Utils;
import com.alipay.mychain.sdk.crypto.hash.Hash;
import com.alipay.mychain.sdk.domain.account.Identity;
import com.alipay.mychain.sdk.errorcode.ErrorCode;
import com.alipay.mychain.sdk.message.query.QueryAccountResponse;
import com.alipay.mychain.sdk.message.query.QueryTransactionResponse;
import com.alipay.mychain.sdk.message.transaction.account.CreateAccountResponse;
import com.alipay.mychain.sdk.message.transaction.account.DepositDataResponse;
import com.example.demo.coll.entity.*;
import com.example.demo.coll.server.CommodityCochain;
import com.example.demo.coll.vo.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @Created by:   zhulei
 * 2020/8/17 17:12
 * code is far away from bug with the animal protecting
 * ┏┓　　　┏┓
 * ┏┛┻━━━┛┻┓
 * ┃　　　　　　　┃
 * ┃　　　━　　　┃
 * ┃　┳┛　┗┳　┃
 * ┃　　　　　　　┃
 * ┃　　　┻　　　┃
 * ┃　　　　　　　┃
 * ┗━┓　　　┏━┛
 * 　　┃　　　┃神兽保佑
 * 　　┃　　　┃代码无BUG！
 * 　　┃　　　┗━━━┓
 * 　　┃　　　　　　　┣┓
 * 　　┃　　　　　　　┏┛
 * 　　┗┓┓┏━┳┓┏┛
 * 　　　┃┫┫　┃┫┫
 * 　　　┗┻┛　┗┻┛
 */
@RestController
@Scope("prototype")
public class Api {
    @RequestMapping("/register")
    public Result<User> register(HttpServletResponse response, String accountName) throws Exception {
        response.setHeader( "Access-Control-Allow-Origin", "*" );
        response.setHeader( "Cache-Control", "no-cache" );
        Result<User> result = new Result<User>();

        CommodityCochain commodityCochain = new CommodityCochain();
        CreateAccountResponse createAccountResponse = commodityCochain.inUser( accountName );
        User user = new User();

        if (!createAccountResponse.isSuccess() || createAccountResponse.getTransactionReceipt().getResult() != 0) {
            result.setMessage( getErrorMsg( (int) createAccountResponse.getTransactionReceipt().getResult() ) );
            result.setResult( user );
            result.setSuccess( false );
            result.setCode( 400 );
        } else {
            QueryTransactionResponse queryTransactionResponse =
                    commodityCochain.getTr( createAccountResponse.getTxHash() );
//            System.err.println(queryTransactionResponse.getTransaction().getData().);
//            user.setUserAddress( queryTransactionResponse.getTransaction().getTo() );
//            user.setUserBlockNumber( queryTransactionResponse.getBlockNumber() );
//            user.setUserHash( queryTransactionResponse.getTransaction().getHash() );
//            user.setUserHashStr( queryTransactionResponse.getTransaction().getHash().hexStrValue() );
            user.setUserAddressStr( queryTransactionResponse.getTransaction().getTo().hexStrValue() );
            result.setCode( 200 );
            result.setMessage( "success" );
            result.setResult( user );
            result.setSuccess( true );
        }
        return result;
    }

    //查询用户
    @RequestMapping("/queryAccount")
    public Result<User> queryAccount(HttpServletResponse response, String accountName) throws Exception {
        response.setHeader( "Access-Control-Allow-Origin", "*" );
        response.setHeader( "Cache-Control", "no-cache" );
        Result<User> result = new Result<User>();

        CommodityCochain commodityCochain = new CommodityCochain();
        QueryAccountResponse queryAccountResponse = commodityCochain.queryAccount( accountName );
        User user = new User();

        if (!queryAccountResponse.isSuccess() ) {
            result.setMessage( "err" );
            result.setResult( user );
            result.setSuccess( false );
            result.setCode( 400 );
        } else {
//            QueryTransactionResponse queryTransactionResponse =
//                    commodityCochain.getTr( queryAccountResponse. );
//            System.err.println(queryTransactionResponse.getTransaction().getData().);
//            user.setUserAddress( queryTransactionResponse.getTransaction().getTo() );
//            user.setUserBlockNumber( queryTransactionResponse.getBlockNumber() );
//            user.setUserHash( queryTransactionResponse.getTransaction().getHash() );
//            user.setUserHashStr( queryTransactionResponse.getTransaction().getHash().hexStrValue() );
            user.setUserAddressStr( queryAccountResponse.getAccount().getIdentity().hexStrValue() );
            result.setCode( 200 );
            result.setMessage( "success" );
            result.setResult( user );
            result.setSuccess( true );
        }
        return result;
    }

    //部署合约
    @RequestMapping("/deployContract")
    public Result<String> deployContract(HttpServletResponse response) throws Exception {
        response.setHeader( "Access-Control-Allow-Origin", "*" );
        response.setHeader( "Cache-Control", "no-cache" );

        Result<String> result = new Result<String>();

        CommodityCochain commodityCochain = new CommodityCochain();

        String s = commodityCochain.deployContract();

        result.setMessage( "success" );
        result.setResult( s );
        result.setSuccess( true );
        result.setCode( 200 );
        return result;
    }

    //查询
    @RequestMapping("/map")
    public Result<Commodity> map(HttpServletResponse response, long tokenId) throws Exception {
        response.setHeader( "Access-Control-Allow-Origin", "*" );
        response.setHeader( "Cache-Control", "no-cache" );

        Result<Commodity> result = new Result<Commodity>();

        CommodityCochain commodityCochain = new CommodityCochain();

        Commodity commodity = commodityCochain.map( tokenId );

        if (commodity.getState()) {
            result.setMessage( "success" );
            result.setResult( commodity );
            result.setSuccess( true );
            result.setCode( 200 );
        } else {
            result.setMessage( "err" );
            result.setResult( commodity );
            result.setSuccess( false );
            result.setCode( 400 );
        }
        return result;
    }

    //查看账户下多少商品
    @RequestMapping("/Count")
    public Result<CCount> Count(HttpServletResponse response, String addr) throws Exception {
        response.setHeader( "Access-Control-Allow-Origin", "*" );
        response.setHeader( "Cache-Control", "no-cache" );

        Result<CCount> result = new Result<CCount>();

        CommodityCochain commodityCochain = new CommodityCochain();

        CCount cCount = commodityCochain.ownerAntCount( addr );

        if (cCount.getState()) {
            result.setMessage( "success" );
            result.setResult( cCount );
            result.setSuccess( true );
            result.setCode( 200 );
        } else {
            result.setMessage( "err" );
            result.setResult( cCount );
            result.setSuccess( false );
            result.setCode( 400 );
        }
        return result;
    }

    //铸造
    @RequestMapping("/IssueAddr")
    public Result<IssueAddrEntity> IssueAddr(HttpServletResponse response, String account, long nftId, String tokenUrl) throws Exception {
        response.setHeader( "Access-Control-Allow-Origin", "*" );
        response.setHeader( "Cache-Control", "no-cache" );

        Result<IssueAddrEntity> result = new Result<IssueAddrEntity>();

        CommodityCochain commodityCochain = new CommodityCochain();

        IssueAddrEntity issueAddrEntity = commodityCochain.IssueAddr( account, nftId, tokenUrl );

        if (issueAddrEntity.getState()) {
            result.setMessage( "success" );
            result.setResult( issueAddrEntity );
            result.setSuccess( true );
            result.setCode( 200 );
        } else {
            result.setMessage( "err" );
            result.setResult( issueAddrEntity );
            result.setSuccess( false );
            result.setCode( 400 );
        }
        return result;
    }

    //转移
    @RequestMapping("/transferFrom")
    public Result<TransferFromEntity> transferFrom(HttpServletResponse response, String from, String to, long tokenId) throws Exception {
        response.setHeader( "Access-Control-Allow-Origin", "*" );
        response.setHeader( "Cache-Control", "no-cache" );

        Result<TransferFromEntity> result = new Result<TransferFromEntity>();

        CommodityCochain commodityCochain = new CommodityCochain();

        TransferFromEntity transferFromEntity = commodityCochain.transferFrom( from, to, tokenId );

        if (transferFromEntity.getState()) {
            result.setMessage( "success" );
            result.setResult( transferFromEntity );
            result.setSuccess( true );
            result.setCode( 200 );
        } else {
            result.setMessage( "err" );
            result.setResult( transferFromEntity );
            result.setSuccess( false );
            result.setCode( 400 );
        }
        return result;
    }

    @RequestMapping("/selUser")
    public Result<String> selUser(HttpServletResponse response) throws Exception {
        response.setHeader( "Access-Control-Allow-Origin", "*" );
        response.setHeader( "Cache-Control", "no-cache" );

        Result<String> result = new Result<String>();

        CommodityCochain commodityCochain = new CommodityCochain();
        System.err.println( Utils.getIdentityByName( "AYSC" ));
        System.err.println( Utils.getIdentityByName( "AYSCHY" ));
        String s = commodityCochain.selUser();

            result.setMessage( "success" );
            result.setResult( s );
            result.setSuccess( true );
            result.setCode( 200 );

        return result;
    }

    //--------------------下面是1.0--------上面是2.0合约版
    @RequestMapping("/creatGoods")
    public Result<JSONObject> CreatGoods(HttpServletResponse response,
                                         String tokenUrl,
                                         String commodityId) throws Exception {
        response.setHeader( "Access-Control-Allow-Origin", "*" );
        response.setHeader( "Cache-Control", "no-cache" );

        Result<JSONObject> result = new Result<JSONObject>();
        JSONObject json = new JSONObject();

        CommodityCochain commodityCochain = new CommodityCochain();

        DepositDataResponse depositDataResponse = commodityCochain.coChain( commodityId, tokenUrl );

        if (!depositDataResponse.isSuccess() || depositDataResponse.getTransactionReceipt().getResult() != 0) {
            result.setMessage( getErrorMsg( (int) depositDataResponse.getTransactionReceipt().getResult() ) );
            result.setResult( null );
            result.setSuccess( false );
            result.setCode( 400 );
        } else {
            result.setMessage( "success" );
            json.put( "hash", depositDataResponse.getTxHash().hexStrValue() );
            result.setResult( json );
            result.setSuccess( true );
            result.setCode( 200 );
        }
        return result;
    }

    @RequestMapping("/transfer")
    public Result<JSONObject> transfer(HttpServletResponse response,
                                       String commodityHash,
                                       String fromAccountName,
                                       String toAccountName) throws Exception {
        response.setHeader( "Access-Control-Allow-Origin", "*" );
        response.setHeader( "Cache-Control", "no-cache" );

        Result<JSONObject> result = new Result<JSONObject>();
        JSONObject json = new JSONObject();

        CommodityCochain commodityCochain = new CommodityCochain();

        DepositDataResponse depositDataResponse = commodityCochain.transfer( commodityHash, fromAccountName, toAccountName );

        if (!depositDataResponse.isSuccess() || depositDataResponse.getTransactionReceipt().getResult() != 0) {
            result.setMessage( getErrorMsg( (int) depositDataResponse.getTransactionReceipt().getResult() ) );
            result.setResult( null );
            result.setSuccess( false );
            result.setCode( 400 );
        } else {
            result.setMessage( "success" );
            json.put( "hash", depositDataResponse.getTxHash().hexStrValue() );
            result.setResult( json );
            result.setSuccess( true );
            result.setCode( 200 );
        }
        return result;
    }

    @RequestMapping("/off")
    public Result<Boolean> off(HttpServletResponse response) {
        response.setHeader( "Access-Control-Allow-Origin", "*" );
        response.setHeader( "Cache-Control", "no-cache" );

        Result<Boolean> result = new Result<Boolean>();
        CommodityCochain commodityCochain = new CommodityCochain();

        Boolean b = commodityCochain.off();
        if (b) {
            result.setMessage( "success" );
            result.setResult( b );
            result.setSuccess( b );
            result.setCode( 200 );
        } else {
            result.setMessage( "未启动sdk" );
            result.setResult( b );
            result.setSuccess( b );
            result.setCode( 400 );
        }


        return result;
    }

    private static String getErrorMsg(int errorCode) {
        int minMychainSdkErrorCode = ErrorCode.SDK_INTERNAL_ERROR.getErrorCode();
        if (errorCode < minMychainSdkErrorCode) {
            return ErrorCode.valueOf( errorCode ).getErrorDesc();
        } else {
            return ErrorCode.valueOf( errorCode ).getErrorDesc();
        }
    }
}
